using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Tao.OpenGl;
using Tao.Platform.Windows;
namespace Blending
{    
    public partial class BlendingForm : Form
    {
        #region Attributes
        Icon newIcon;
        public int viewportW = 800, viewportH = 600;
        public double winX = 4;
        public double winY = 4;
        //public double winZ=10.0;
        public Rectangle rec;
        public static int theta=0;
        float[] lightPos ={ 0.5f, 0.8f, 2.0f, 0.0f };

        float[] mat_nil ={ 0.0f, 0.0f, 0.0f, 1.0f };
        float[] mat_amb ={ 0.2f, 0.2f, 0.2f, 1.0f };
        float[] mat_diff ={ 0.84f, 0.5f, 0.7f, 1.0f };
        float[] mat_spec ={ 0.2f, 0.2f, 0.2f, 1.0f };
        float[] emission ={ 0.2f, 0.2f, 0.2f, 1.0f };

        float no_shininess = 0.0f;
        float low_shininess = 20.0f;
        float high_shininess = 100;
        #endregion
        
        public BlendingForm()
        {
            InitializeComponent();
            glControl.InitializeContexts();
            initializeOpenGL();
            this.SetBounds(0, 0, viewportW, viewportH);
            getIconFromBitmap();
        }
        public void getIconFromBitmap()
        {
            Bitmap myBitmap = new Bitmap(@"..\..\Images\rose12.jpg");
            IntPtr Hicon = myBitmap.GetHicon();
            newIcon = Icon.FromHandle(Hicon);
            this.Icon = newIcon;
            //DestroyIcon(newIcon.Handle);
        }
        private void initializeOpenGL()
        {
            Gl.glViewport(0, 0, viewportW, viewportH);

            Gl.glMatrixMode(Gl.GL_PROJECTION);
            Gl.glLoadIdentity();
            Glu.gluPerspective(90, 1.4, 0.1, 10);

            Gl.glMatrixMode(Gl.GL_MODELVIEW);
            Gl.glLoadIdentity();            
            Glu.gluLookAt(0.0, 0.0, 4.0, 0, 0, 0, 0, 1, 0);

            Gl.glClearColor(0, 0, 0, 1);
            Gl.glClear(Gl.GL_COLOR_BUFFER_BIT | Gl.GL_DEPTH_BUFFER_BIT);
            Gl.glEnable(Gl.GL_DEPTH_TEST);
            Gl.glShadeModel(Gl.GL_SMOOTH);

            Gl.glEnable(Gl.GL_BLEND);
            Gl.glBlendFunc(Gl.GL_SRC_ALPHA, Gl.GL_ONE_MINUS_SRC_ALPHA);

            initLights();            
        }

        private void initLights()
        {
            Gl.glLightfv(Gl.GL_LIGHT0, Gl.GL_POSITION, lightPos);

            Gl.glMaterialfv(Gl.GL_FRONT, Gl.GL_AMBIENT, mat_amb);
            Gl.glMaterialfv(Gl.GL_FRONT, Gl.GL_DIFFUSE, mat_diff);
            Gl.glMaterialfv(Gl.GL_FRONT, Gl.GL_SPECULAR, mat_spec);
            Gl.glMaterialf(Gl.GL_FRONT, Gl.GL_SHININESS, high_shininess);
            Gl.glMaterialfv(Gl.GL_FRONT, Gl.GL_EMISSION, emission);

            Gl.glEnable(Gl.GL_LIGHTING);
            Gl.glEnable(Gl.GL_LIGHT0);

            Gl.glEnable(Gl.GL_COLOR_MATERIAL);
            Gl.glColorMaterial(Gl.GL_FRONT, Gl.GL_DIFFUSE);
        }
        private void glControl_Paint(object sender, PaintEventArgs e)
        {
            Gl.glClear(Gl.GL_COLOR_BUFFER_BIT | Gl.GL_DEPTH_BUFFER_BIT);
            Gl.glDisable(Gl.GL_BLEND);
            
            Gl.glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
            
            drawStage();
            
            Gl.glPushMatrix();                
                Gl.glColor4f(0.11f, 0.25f, 0.72f, 0.7f);
                Gl.glTranslated(0.0, 1.2, 0.75);
                Gl.glRotated(90, 1, 0, 0);
                Cylinder(0.1, 0.1, 2.6, 40, 40);
            Gl.glPopMatrix();

            Gl.glEnable(Gl.GL_BLEND);
            Gl.glEnable(Gl.GL_CULL_FACE);
            Gl.glCullFace(Gl.GL_BACK);

            Gl.glPushMatrix();
                Gl.glRotated(theta, 0, 1, 0);
                Gl.glTranslated(1.0, 0.0, 0.0);
                Gl.glColor4f(0.11f, 0.65f, 0.12f, 0.7f);
			    Sphere(0.3,20,20);
            Gl.glPopMatrix();

            Gl.glPushMatrix();
                Gl.glRotated(theta, 1, 1, 1);
                Gl.glTranslated(0.0, 1.0, 0.0);
                Gl.glColor4f(0.71f, 0.65f, 0.12f, 0.7f);
                Sphere(0.3, 20, 20);
            Gl.glPopMatrix();

            Gl.glDisable(Gl.GL_BLEND);
            Gl.glDisable(Gl.GL_CULL_FACE); 
            theta++;
            //glControl.SwapBuffers();
            glControl.Invalidate();
        }

        private void glControl_Resize(object sender, EventArgs e)
        {
            rec = ClientRectangle;
            viewportW = rec.Width;
            viewportH = rec.Height;

            Gl.glViewport(0, 0, viewportW, viewportH);
            Gl.glMatrixMode(Gl.GL_PROJECTION);
            Gl.glLoadIdentity();
            Glu.gluPerspective(60, 1.4, 0.1, 10);
            //if (viewportW > viewportH)
            //    Gl.glOrtho(-winX * viewportW / viewportH, winX * viewportW / viewportH, -winY, winY, -10, 10);
            //else
            //    Gl.glOrtho(-winX, winX, -winY * viewportH / viewportW, winY * viewportH / viewportW, -10, 10);
            Gl.glMatrixMode(Gl.GL_MODELVIEW);
            Gl.glLoadIdentity();
            Glu.gluLookAt(0.0, 0.0, 4.0, 0, 0, 0, 0, 1, 0);
            glControl.Invalidate();
        }
        private void glControl_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Escape)
                Application.Exit();
        }  
        void drawStage()
        {
            // material for the walls, floor, ceiling
            float[] wallColor = { 1.0f, 1.0f, 1.0f, 1.0f };
            Gl.glMaterialfv(Gl.GL_FRONT, Gl.GL_AMBIENT_AND_DIFFUSE, wallColor);

            Gl.glBegin(Gl.GL_QUADS);
          
		        // floor 
		        Gl.glNormal3f(0, 1, 0);
		        Gl.glVertex3f(-1.25f, -1.25f, 1.25f);
		        Gl.glVertex3f(1.25f, -1.25f, 1.25f);
		        Gl.glVertex3f(1.25f, -1.25f, -1.25f);
		        Gl.glVertex3f(-1.25f, -1.25f, -1.25f);

		        // ceiling 
		        Gl.glNormal3f(0, -1, 0);
		        Gl.glVertex3f(-1.25f, 1.25f, -1.25f);
		        Gl.glVertex3f(1.25f, 1.25f, -1.25f);
		        Gl.glVertex3f(1.25f, 1.25f, 1.25f);
		        Gl.glVertex3f(-1.25f, 1.25f, 1.25f);  

		        // left wall 
		        Gl.glNormal3f(1, 0, 0);
		        Gl.glVertex3f(-1.25f, -1.25f, -1.25f);
		        Gl.glVertex3f(-1.25f, -1.25f, 1.25f);
		        Gl.glVertex3f(-1.25f, 1.25f, 1.25f);
		        Gl.glVertex3f(-1.25f, 1.25f, -1.25f);

		        // right wall 
		        Gl.glNormal3f(-1, 0, 0);
		        Gl.glVertex3f(1.25f, 1.25f, -1.25f);
		        Gl.glVertex3f(1.25f, 1.25f, 1.25f);
		        Gl.glVertex3f(1.25f, -1.25f, 1.25f);
		        Gl.glVertex3f(1.25f, -1.25f, -1.25f);

		        // far wall 
		        Gl.glNormal3f(0, 0, 1);
		        Gl.glVertex3f(-1.25f, -1.25f, -1.25f);
		        Gl.glVertex3f(1.25f, -1.25f, -1.25f);
		        Gl.glVertex3f(1.25f, 1.25f, -1.25f);
		        Gl.glVertex3f(-1.25f, 1.25f, -1.25f);

            Gl.glEnd();
        }
        #region Objects rendered(Sphere,Disk,Cylinder,Cone,Cube)
        public void Sphere(double radius, int slices, int stacks)
        {
            Glu.GLUquadric quad = Glu.gluNewQuadric();
            Glu.gluQuadricDrawStyle(quad, Glu.GLU_FILL);//GLU_POINT,GLU_LINE,GLU_SILHOUETTE
            Glu.gluQuadricNormals(quad, Glu.GLU_SMOOTH);
            //Glu.gluQuadricOrientation(quad, Glu.GLU_INSIDE);
            Glu.gluSphere(quad, radius, slices, stacks);
        }
        public void Disk(double inRadius, double outRadius, int slices, int stacks)
        {
            Glu.GLUquadric quad = Glu.gluNewQuadric();
            Glu.gluQuadricDrawStyle(quad, Glu.GLU_FILL);//GLU_POINT,GLU_LINE,GLU_SILHOUETTE
            Glu.gluQuadricNormals(quad, Glu.GLU_SMOOTH);
            Glu.gluDisk(quad, inRadius, outRadius, slices, stacks);
        }
        public void Cylinder(double baseRadius, double topRadius, double height, int slices, int stacks)
        {
            Glu.GLUquadric quad = Glu.gluNewQuadric();
            Glu.gluQuadricDrawStyle(quad, Glu.GLU_FILL);//GLU_POINT,GLU_LINE,GLU_SILHOUETTE
            Glu.gluQuadricNormals(quad, Glu.GLU_FLAT);//SMOOTH);
            Glu.gluCylinder(quad, baseRadius, topRadius, height, slices, stacks);
        }
        public void Cone(double baseRadius, double height, int slices, int stacks)
        {
            Glu.GLUquadric quad = Glu.gluNewQuadric();
            Glu.gluQuadricDrawStyle(quad, Glu.GLU_FILL);//GLU_POINT,GLU_LINE,GLU_SILHOUETTE
            Glu.gluQuadricNormals(quad, Glu.GLU_SMOOTH);
            Glu.gluCylinder(quad, baseRadius, 0.0, height, slices, stacks);
        }
        public void Cube(double side)
        {
            double hs = side / 2.0;
            double[,] vertex = {{hs,hs,hs},
                                {hs,hs,-hs},
                                {-hs,hs,-hs},
                                {-hs,hs,hs},
                                {hs,-hs,hs},
                                {hs,-hs,-hs},
                                {-hs,-hs,-hs},
                                {-hs,-hs,hs}};
            int[,] face ={  {0,1,2,3},
                            {7,6,5,4},           
                            {0,4,5,1},
                            {6,7,3,2},
                            {0,3,7,4},
                            {2,1,5,6}};
            double[,] normal ={ {0,1,0},
                                {0,-1,0},
                                {1,0,0},
                                {-1,0,0},
                                {0,0,1},
                                {0,0,-1}};
            Gl.glBegin(Gl.GL_QUADS);            
                for (int f = 0; f < 6; f++)
                {
                    for (int v = 0; v < 4; v++)
                    {
                        Gl.glNormal3d(normal[f, 0], normal[f, 1], normal[f, 2]);
                        Gl.glVertex3d(vertex[face[f, v], 0], vertex[face[f, v], 1], vertex[face[f, v], 2]);
                    }
                }
            Gl.glEnd();
        }
        #endregion
    }
}